<?
function webmail_plus_solr_cron() {
	$_debug = variable_get('webmail_plus_solr_debug', FALSE);
	
	if($_debug) echo "running webmail_plus_solr_cron<br>\n";
	  
	// clear everything
	
	db_query("TRUNCATE TABLE {webmail_plus_solr_history}");
	db_query("TRUNCATE TABLE {webmail_plus_solr_map}");
	db_query("TRUNCATE TABLE {webmail_plus_solr_results}");
	db_query("TRUNCATE TABLE {webmail_plus_solr_results_headers}");
	
	
	// fetch solr config
	$solr_url = variable_get('webmail_plus_solr_url', NULL);
	$solr_url_parts = parse_url($solr_url);  
	$solr_batch_size = variable_get('webmail_plus_solr_batch_size', 10);
	  
	$solr_ignore_folders = variable_get('webmail_plus_solr_ignore_folders', NULL);
	$solr_ignore_folders_arr = explode(',', $solr_ignore_folders);
	foreach($solr_ignore_folders_arr as $key=>$value) {
		$solr_folder_blacklist[trim($value)]=trim($value);
	}
	
	// load solr classes
  $include_path = get_include_path();
  $apachesolr_path = './'. drupal_get_path('module', 'apachesolr') .'/SolrPhpClient/';
  $full_path = $include_path.':'.$apachesolr_path;
  set_include_path($full_path);
  include_once('Apache/Solr/Service.php');
    
	// create a new solr object
	$solr = new Apache_Solr_Service($solr_url_parts['host'],  $solr_url_parts['port'], $solr_url_parts['path']);
	    
	if (!$solr->ping()) {
	  if($_debug) echo (t('No Solr instance available during indexing'));
	  return;
	}
	else {
	  if($_debug) echo "Connected to Solr<br>\n";
	}
	    
	$all_users = db_query("SELECT DISTINCT (webmail_plus_solr_queue.uid), webmail_plus_user_passwords.password FROM {webmail_plus_solr_queue} LEFT JOIN webmail_plus_user_passwords ON webmail_plus_solr_queue.uid = webmail_plus_user_passwords.uid WHERE webmail_plus_user_passwords.password!=''");
	    
	// go thru all users 1 by 1 
	
	while($user = db_fetch_object($all_users)) {
	  $user_node = user_load($user->uid);
	  $user_password = _webmail_plus_get_user_password($user);
	 
	  
	  //echo "processing ".$user->name."<br>\n";
	  // clear search results
	  _webmail_plus_solr_clear_results($user_node);
	  
	  // fetch all messages that belong to this user
	  $user_messages = db_query("SELECT action,message_key FROM {webmail_plus_solr_queue} WHERE uid=%d AND action='ADD'", $user->uid);
	      
	  while($user_message = db_fetch_object($user_messages)) {
	  	
	    $message_key_parts = webmail_plus_parse_message_key($user_message->message_key);
	    
	    // if the folder is in the backlist, simply remove the action, do not index it
	    if($solr_folder_blacklist[$message_key_parts->folder]) {
	    	_webmail_plus_solr_delete_queue($user_message->uid, $user_message->action, $user_message->message_key);
	    	continue;
	    }
	    
	      // if the message is already in the map, skip it
	    if(_webmail_plus_solr_check_map($user_message->message_key, $user)) {
	      _webmail_plus_solr_delete_queue($user_message->uid, $user_message->action, $user_message->message_key);
	      continue;
	    }
	        
	
	     // get message properties
	     $mail_api_connection = webmail_plus_solr_connect($user_node->name, $user_password, $message_key_parts->folder);
	     $message_header = webmail_plus_parse_header(mail_api_header($message_key_parts->message_uid), TRUE);
	      //wpd($message_header);
	     $message_plaintext = mail_api_get_plaintext($message_key_parts->message_uid);
	     $message_attachments = mail_api_get_attachment_files($message_key_parts->message_uid);
	      
	       //wpd($message_attachments);
	      
	     if(is_array($message_attachments)) {
	       $msg_num_attach = sizeof($message_attachments);
	     }
	     else {
	       $msg_num_attach = 0;
	     }
	      
	      //echo "number of attachments: $msg_num_attach<br>\n";
	      
	     if($msg_num_attach>0) {
	        $msg_attach_filenames = implode(', ', _webmail_plus_extract_filenames($message_attachments));
	     }
	     else {
	      	$msg_attach_filenames = '';
	     }
	      //echo "attachment list: $msg_attach_filenames<br>\n";
	      //wpd($msg_attach_filenames);
	      
	      // reformat the date into solr format
	     $message_date = date("Y-m-d\TH:i:s\Z", strtotime($message_header['date']));
	    
	
	     
	     // create a document to be submitted to solr
	     unset($document);
	     $document = new Apache_Solr_Document();
	     $document->drupal_uid = $user->uid;
	     $document->msg_id = $user_message->message_key;
	     $document->msg_from = $message_header['from'];
	     $document->msg_to = $message_header['to'];
	     $document->msg_cc = $message_header['cc'];
	     $document->msg_bcc = $message_header['bcc'];
	     $document->msg_subject = $message_header['subject'];
	     $document->msg_date = $message_date;
	     $document->msg_plain = $message_plaintext;
	     $document->msg_body = $message_plaintext;
	     $document->msg_num_attach = $msg_num_attach;
	     $document->msg_attach_filenames = $msg_attach_filenames;

	     
	     wpd($document);
	     if (is_object($solr)) {
	     	try {
	       $solr -> addDocument($document);
	       $solr -> commit();
	       $solr -> optimize(FALSE, FALSE);	     		
	     	}
	      catch (Exception $e) {
	      	echo $e->getMessage()."<br>\n";
          watchdog('Webmail Plus Solr', $e->getMessage(), NULL, WATCHDOG_ERROR);
        }
	     }
	      
	  }
	    
	}

}


/**
 * takes an attachment array and extracts just the filenames
 *
 * @param unknown_type $attachments
 * @return unknown
 */
function _webmail_plus_extract_filenames($attachments) {
	if(!is_array($attachments)) return FALSE;
	
	foreach($attachments as $index=>$attachment_info) {
		if($attachment_info['file']) $rs[]=$attachment_info['file'];
	}
	
	return $rs;
}
 ?>