<?php


function webmail_plus_preferences_presentation($user=NULL) {
	
  global $_webmail_plus_config, $_webmail_plus_user_preferences;

  if(!$user) global $user;




  $form['general'] = array(
  '#type' => 'fieldset',
    '#title' => t('General Settings'),
    '#collapsible' => TRUE,
    '#collapsed' => FALSE,
  );


  $options = array(
    '25' => '25',
    '50' => '50',
    '75' => '75',
    '100' => '100'
  );

  $form['general']['conversations_per_page'] = array(
    '#type' => 'select',
    '#title' => t('Conversations per page'),
    '#options' => $options,
    '#default_value' => $_webmail_plus_user_preferences->conversations_per_page
  );

  if($_webmail_plus_config->email_format_override) {
    $email_format_options = array(
      'plaintext' => t('Plain Text'),
      'html' => t('HTML')
    );
      
    if(!$_webmail_plus_user_preferences->email_format) {
      $_webmail_plus_user_preferences->email_format="plaintext";
    }
    
    
    $form['general']['email_format'] = array(
      '#type' => 'radios',
      '#title' => t('Preferred email format'),
      '#default_value' => $_webmail_plus_user_preferences->email_format,
      '#options' => $email_format_options,      
      '#description' => t('Defines the format used for outbound email.')    
    );
  }  
  
  //print_r($_webmail_plus_user_preferences);

  if($_webmail_plus_config->thread_messages_user_override) {
    $form['message_threading'] = array(
      '#type' => 'fieldset',
      '#title' => t('Message Threading'),
      '#collapsible' => TRUE,
      '#collapsed' => FALSE,
    );

    $form['message_threading']['thread_messages'] = array(
      '#type' => 'checkbox',
      '#title' => t('Group similar messages into threads'),
      '#default_value' => $_webmail_plus_user_preferences->thread_messages,
      '#description' => t('Message replies will be organized into a coversation.')
    );
  }
  


  $form['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save'),
  );

  return $form;
}


function theme_webmail_plus_preferences_presentation($form) {
  $content = drupal_render($form);
  return $content;
}

function webmail_plus_preferences_presentation_submit($form, &$form_state) {
  global $user, $_webmail_plus_config;


  //print_r($form_state);
  webmail_plus_set_user_preference('conversations_per_page', $form_state['values']['conversations_per_page']);

  if($_webmail_plus_config->thread_messages_user_override) {
      drupal_set_message('setting tread messages');
      webmail_plus_set_user_preference('thread_messages', $form_state['values']['thread_messages']);

  }



  drupal_set_message(t('Your Webmail Plus preferences were updated'));

  $form_state['redirect']='user/'.$user->uid.'/webmail_plus';
}
?>